
#include "time.h"
#include <fcntl.h>
#include <unistd.h>

#include "ICubeDefines.h"
#include "HelperFunc.h"


//-------------------------------------------------
// für FrameCnter
CFpsCounter::CFpsCounter()
{
oldmsecs= -1;
}
//---------------------------------------------------------------------------
//
unsigned long CFpsCounter::GetTickCount(void)
{
timespec tp;
    ::clock_gettime (CLOCK_MONOTONIC, &tp);

    return (tp.tv_sec * 1000 + tp.tv_nsec / 1000000);
}
//---------------------------------------------------------------------------
//
void CFpsCounter::ResetFpsCnt(void)
{
   cntx=0;
   cnt=0;
   fpsBak=0;
}
//---------------------------------------------------------------------------
double CFpsCounter::FpsCnt(void)
{
unsigned long msecs;
double fps=0;
double dOut;
	
    if(cntx==0)
        oldmsecs= GetTickCount();
    cntx++ ;
    msecs= GetTickCount();

    if((msecs-oldmsecs)>0)
        fps=((cntx*1000)/(msecs-oldmsecs));

    if(cnt == 100)
    {
        fpsBak = fpsBak/100*10;
        cnt = 11;
        fpsBak += fps;
        dOut= fpsBak/cnt;
        cnt++;            
        return dOut;
    }

  if(cnt==0)
        dOut=fps;
    else                // Mittelwert
    {
        fpsBak += fps;
        dOut= fpsBak/cnt;
    }
	
cnt++;
return dOut;
}
//------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
//
int SaveRaw(void* pBuffer, unsigned int nBufferSize)
{
// file descriptor of the output file
int gFileDescriptor = -1;

	gFileDescriptor = open("test.raw", (O_WRONLY | O_CREAT), 0644);
	if (gFileDescriptor < 0) 
		return 1;
	
	int err = write(gFileDescriptor, pBuffer, nBufferSize);
	if (err < 0) 
		return 1;
		
	close(gFileDescriptor);
	
return 0;
}