#include "ICubeAPI.h"
#include <QLibrary>


QLibrary ICubeLib("libNETUSBCAM_debug");
//QLibrary ICubeLib("libNETUSBCAM");

 PICubeInit 			ICubeInit;
 PICubeGetApiVersion 	ICubeGetApiVersion;
 PICubeOpen 			ICubeOpen;
 PICubeClose 			ICubeClose;
 PICubeStart 			ICubeStart;
 PICubeStop 			ICubeStop;
 PICubeGetName 			ICubeGetName;
 PICubeGetModeList 		ICubeGetModeList;
 PICubeSetMode 			ICubeSetMode;
 PICubeGetMode 			ICubeGetMode;
 PICubeSetCallback 		ICubeSetCallback;
 PICubeGetBinSkipList 	ICubeGetBinSkipList;
 PICubeSetBinSkip 		ICubeSetBinSkip;
 PICubeGetResolution 	ICubeGetResolution;
 PICubeSetResolution 	ICubeSetResolution;
 PICubeGetSize 			ICubeGetSize;
 PICubeGetBinSkip 		ICubeGetBinSkip;
 PICubeGetResolutionRange ICubeGetResolutionRange;
 PICubeSetCamParameter 	ICubeSetCamParameter;
 PICubeGetCamParameter 	ICubeGetCamParameter;
 PICubeGetCamParameterRange ICubeGetCamParameterRange;
 PICubeGetParamAuto 	ICubeGetParamAuto;
 PICubeSetParamAuto 	ICubeSetParamAuto;
 PICubeSetParamAutoDef 	ICubeSetParamAutoDef; 
 PICubeSetParamOnePush 	ICubeSetParamOnePush;
 PICubeGetFWVersion 	ICubeGetFWVersion;
 PICubeGetTrigger 		ICubeGetTrigger;
 PICubeSetTrigger 		ICubeSetTrigger;
 PICubeSaveToFile 		ICubeSaveToFile;
 PICubeGetBrokenFrames  ICubeGetBrokenFrames;
 PICubeGetGoodFrames 	ICubeGetGoodFrames;
 PICubeSetExposure 		ICubeSetExposure;
 PICubeGetExposure 		ICubeGetExposure;
 PICubeGetExposureRange ICubeGetExposureRange;

bool LoadICubeAPI(void)
{

  ICubeInit = (PICubeInit) ICubeLib.resolve("NETUSBCAM_Init");
  ICubeGetApiVersion = (PICubeGetApiVersion) ICubeLib.resolve("NETUSBCAM_GetApiVersion");
  ICubeOpen = (PICubeOpen) ICubeLib.resolve("NETUSBCAM_Open");
  ICubeClose = (PICubeClose) ICubeLib.resolve("NETUSBCAM_Close");
  ICubeStart = (PICubeStart) ICubeLib.resolve("NETUSBCAM_Start");
  ICubeStop = (PICubeStop) ICubeLib.resolve("NETUSBCAM_Stop");
  ICubeGetName = (PICubeGetName) ICubeLib.resolve("NETUSBCAM_GetName");
  ICubeGetModeList = (PICubeGetModeList) ICubeLib.resolve("NETUSBCAM_GetModeList");
  ICubeSetMode = (PICubeSetMode) ICubeLib.resolve("NETUSBCAM_SetMode");
  ICubeGetMode = (PICubeGetMode) ICubeLib.resolve("NETUSBCAM_GetMode");
  ICubeSetCallback = (PICubeSetCallback) ICubeLib.resolve("NETUSBCAM_SetCallback");
  ICubeGetBinSkipList = (PICubeGetBinSkipList) ICubeLib.resolve("NETUSBCAM_GetBinSkipList");
  ICubeSetBinSkip = (PICubeSetBinSkip) ICubeLib.resolve("NETUSBCAM_SetBinSkip");
  ICubeGetResolution = (PICubeGetResolution) ICubeLib.resolve("NETUSBCAM_GetResolution");
  ICubeSetResolution = (PICubeSetResolution) ICubeLib.resolve("NETUSBCAM_SetResolution");
  ICubeGetSize= (PICubeGetSize) ICubeLib.resolve("NETUSBCAM_GetSize");
  ICubeGetBinSkip= (PICubeGetBinSkip) ICubeLib.resolve("NETUSBCAM_GetBinSkip");
  ICubeGetResolutionRange=(PICubeGetResolutionRange) ICubeLib.resolve("NETUSBCAM_GetResolutionRange");
  
  ICubeSetCamParameter=(PICubeSetCamParameter) ICubeLib.resolve("NETUSBCAM_SetCamParameter");
  ICubeGetCamParameter=(PICubeGetCamParameter) ICubeLib.resolve("NETUSBCAM_GetCamParameter");
  ICubeGetCamParameterRange=(PICubeGetCamParameterRange) ICubeLib.resolve("NETUSBCAM_GetCamParameterRange");
  ICubeGetParamAuto=(PICubeGetParamAuto) ICubeLib.resolve("NETUSBCAM_GetParamAuto");
  ICubeSetParamAuto=(PICubeSetParamAuto) ICubeLib.resolve("NETUSBCAM_SetParamAuto");
  ICubeSetParamAutoDef=(PICubeSetParamAutoDef) ICubeLib.resolve("NETUSBCAM_SetParamAutoDef");
  ICubeSetParamOnePush=(PICubeSetParamOnePush) ICubeLib.resolve("NETUSBCAM_SetParamOnePush");

  ICubeGetFWVersion=(PICubeGetFWVersion) ICubeLib.resolve("NETUSBCAM_GetFWVersion");

  ICubeGetTrigger=(PICubeGetTrigger) ICubeLib.resolve("NETUSBCAM_GetTrigger");
  ICubeSetTrigger=(PICubeSetTrigger) ICubeLib.resolve("NETUSBCAM_SetTrigger");

  ICubeSaveToFile=(PICubeSaveToFile) ICubeLib.resolve("NETUSBCAM_SaveToFile");
  
  ICubeGetBrokenFrames=(PICubeGetBrokenFrames) ICubeLib.resolve("NETUSBCAM_GetBrokenFrames");
  ICubeGetGoodFrames=(PICubeGetGoodFrames) ICubeLib.resolve("NETUSBCAM_GetGoodFrames");
   
  ICubeSetExposure=(PICubeSetExposure) ICubeLib.resolve("NETUSBCAM_SetExposure");
  ICubeGetExposure=(PICubeGetExposure) ICubeLib.resolve("NETUSBCAM_GetExposure");
  ICubeGetExposureRange=(PICubeGetExposureRange) ICubeLib.resolve("NETUSBCAM_GetExposureRange");
   
 if(!ICubeLib.isLoaded())
		return false;
		
return true;	
}

void UnloadICubeAPI(void)
{
	ICubeLib.unload();
}
