#include "ViewWindow.h"
#include "glwidget.h"

#include "ICubeAPI.h"
#include "ICubeDefines.h"
#include "dialogimpl.h"

extern void ResetFpsCnt(void);
extern double FpsCnt(void);
extern unsigned long cntFr;
extern double dOut1;

//------------------------------------------------------------------------
//
PreviewWindow::PreviewWindow(QWidget *parent)
     : QWidget(parent)
 {
 	mParent=parent;
 	previewLabel = new QLabel(this);
	Qt::WindowFlags flags = 0;
	flags = Qt::Window; 	
 	setWindowTitle(tr("Preview"));
	QWidget::setWindowFlags(flags);
	
	connect(this, SIGNAL(PreviewEnd()),mParent, SLOT(StopSlot()));    				  
 }
//------------------------------------------------------------------------
// 
void PreviewWindow::closeEvent(QCloseEvent *event)
 {
 	emit PreviewEnd();	// Stop Camera
 	event->accept();
 } 
//------------------------------------------------------------------------


