#ifndef __VIEWMODEDLG_H__
#define __VIEWMODEDLG_H__

#include "ui_ViewModeDialog.h"

class ViewModeDlg : public QDialog, public Ui::ViewModeDialog
{
Q_OBJECT
public:
	ViewModeDlg( QWidget * parent /*= 0*/, Qt::WFlags f = 0 );
	//~ViewModeDlg();
	 void Activate(void);
	 
  signals: 
  void Restart(void);
 	
private:	
	int InitBinSkip(void);
 	int InitRoi(void);
 	unsigned int nModBin[2], nModSkip[2];
 	
 	QWidget *mParent;

private slots:

	void SetROISlot(void);
	void EnableROISlot(void);
	void SetBinSlot(void);
	void SetSkipSlot(void);	
	void SliderXPosSlot(void);	
	void SliderYPosSlot(void);
	void SliderXSizeSlot(void);
	void SliderYSizeSlot(void);
};

#endif // __VIEWMODEDLG_H__
